#include <algorithm>

#include "data.hpp"
#include "iostream.hpp"
#include "file_stream.hpp"

bool DataBase::operator==(const DataBase &other) const {
    if(other.mSize != mSize) {
        return false;
    }
    if(other.mDataPtr == this->mDataPtr) {
        return true;
    }

    return std::equal(other.begin(), other.end(), begin());
}

Data<> loadFile(const std::string &fileName) {
    file_istream input(fileName);

    input.seek(0, std::ios_base::end);
    std::streamsize size = input.tell();

    Data<> data(new uint8_t[size], size);

    input.seek(0);
    input.read(data.begin(), data.size());
    return data;
}
